<?php
define('URL_PREFIX', '../../');
include '../../header.php';
?>

<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<div class="header">
  <div class="headertitle">
<div class="title">src/wadseeker/wadseeker.h</div>  </div>
</div>
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">//------------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">// wadseeker.h</span>
<a name="l00003"></a>00003 <span class="comment">//------------------------------------------------------------------------------</span>
<a name="l00004"></a>00004 <span class="comment">//</span>
<a name="l00005"></a>00005 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00007"></a>00007 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">//</span>
<a name="l00010"></a>00010 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">//</span>
<a name="l00015"></a>00015 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00016"></a>00016 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00017"></a>00017 <span class="comment">// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA</span>
<a name="l00018"></a>00018 <span class="comment">// 02110-1301  USA</span>
<a name="l00019"></a>00019 <span class="comment">//</span>
<a name="l00020"></a>00020 <span class="comment">//------------------------------------------------------------------------------</span>
<a name="l00021"></a>00021 <span class="comment">// Copyright (C) 2009 &quot;Zalewa&quot; &lt;zalewapl@gmail.com&gt;</span>
<a name="l00022"></a>00022 <span class="comment">//------------------------------------------------------------------------------</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __WADSEEKER_H_</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __WADSEEKER_H_</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;QList&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;QString&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;QStringList&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;QUrl&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;entities/waddownloadinfo.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;wadseekerexportinfo.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;wadseekermessagetype.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#define WADSEEKER_CONNECT_TIMEOUT_SECONDS_DEFAULT 30</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#define WADSEEKER_DOWNLOAD_TIMEOUT_SECONDS_DEFAULT 120</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="keyword">class </span>Idgames;
<a name="l00039"></a>00039 <span class="keyword">class </span>WadRetriever;
<a name="l00040"></a>00040 <span class="keyword">class </span>WWWSeeker;
<a name="l00041"></a>00041 
<a name="l00082"></a><a class="code" href="classWadseeker.php">00082</a> <span class="keyword">class </span>WADSEEKER_API <a class="code" href="classWadseeker.php" title="Main controlling class.">Wadseeker</a> : <span class="keyword">public</span> QObject
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084     Q_OBJECT
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     <span class="keyword">public</span>:
<a name="l00092"></a><a class="code" href="classWadseeker.php#a1e7d38b7d26916a4829b7496ad6808b2">00092</a>         <span class="keyword">static</span> <span class="keyword">const</span> QString    defaultSites[];
<a name="l00093"></a>00093 
<a name="l00101"></a><a class="code" href="classWadseeker.php#a1dc1c4bba3e0302217dd11ce603d2148">00101</a>         <span class="keyword">static</span> <span class="keyword">const</span> QString    forbiddenWads[];
<a name="l00102"></a>00102 
<a name="l00106"></a>00106         <span class="keyword">static</span> <span class="keyword">const</span> QString    defaultIdgamesUrl();
<a name="l00107"></a>00107 
<a name="l00113"></a>00113         <span class="keyword">static</span> QStringList      defaultSitesListEncoded();
<a name="l00114"></a>00114 
<a name="l00124"></a>00124         <span class="keyword">static</span> <span class="keywordtype">bool</span>             isForbiddenWad(<span class="keyword">const</span> QString&amp; wad);
<a name="l00125"></a>00125 
<a name="l00129"></a>00129         <a class="code" href="classWadseeker.php" title="Main controlling class.">Wadseeker</a>();
<a name="l00130"></a>00130 
<a name="l00134"></a>00134         ~<a class="code" href="classWadseeker.php" title="Main controlling class.">Wadseeker</a>();
<a name="l00135"></a>00135         
<a name="l00142"></a>00142         <span class="keywordtype">bool</span>                isDownloadingFile(<span class="keyword">const</span> QString&amp; file) <span class="keyword">const</span>;
<a name="l00143"></a>00143 
<a name="l00153"></a>00153         <span class="keywordtype">bool</span>                isWorking() <span class="keyword">const</span>;
<a name="l00154"></a>00154 
<a name="l00165"></a>00165         <span class="keywordtype">void</span>                setCustomSite(<span class="keyword">const</span> QUrl&amp; url);
<a name="l00166"></a>00166 
<a name="l00173"></a>00173         <span class="keywordtype">void</span>                setIdgamesEnabled(<span class="keywordtype">bool</span> bEnabled);
<a name="l00174"></a>00174 
<a name="l00178"></a>00178         <span class="keywordtype">void</span>                setIdgamesUrl(QString archiveURL);
<a name="l00179"></a>00179 
<a name="l00188"></a>00188         <span class="keywordtype">void</span>                setMaximumConcurrentDownloads(<span class="keywordtype">unsigned</span> max);
<a name="l00189"></a>00189 
<a name="l00198"></a>00198         <span class="keywordtype">void</span>                setMaximumConcurrentSeeks(<span class="keywordtype">unsigned</span> max);
<a name="l00199"></a>00199 
<a name="l00210"></a>00210         <span class="keywordtype">void</span>                setPrimarySites(<span class="keyword">const</span> QStringList&amp; urlList);
<a name="l00211"></a>00211 
<a name="l00218"></a>00218         <span class="keywordtype">void</span>                setPrimarySitesToDefault();
<a name="l00219"></a>00219 
<a name="l00229"></a>00229         <span class="keywordtype">void</span>                setTargetDirectory(<span class="keyword">const</span> QString&amp; dir);
<a name="l00230"></a>00230 
<a name="l00243"></a>00243         <span class="keywordtype">void</span>                skipFileCurrentUrl(<span class="keyword">const</span> QString&amp; fileName);
<a name="l00244"></a>00244         
<a name="l00256"></a>00256         <span class="keywordtype">void</span>                skipSiteSeek(<span class="keyword">const</span> QUrl&amp; url);
<a name="l00257"></a>00257         
<a name="l00267"></a>00267         <span class="keywordtype">bool</span>                startSeek(<span class="keyword">const</span> QStringList&amp; wads);
<a name="l00268"></a>00268 
<a name="l00275"></a>00275         QString             targetDirectory() <span class="keyword">const</span>;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277     <span class="keyword">public</span> slots:
<a name="l00282"></a>00282         <span class="keywordtype">void</span>                abort();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     signals:
<a name="l00293"></a>00293         <span class="keywordtype">void</span> allDone(<span class="keywordtype">bool</span> bSuccess);
<a name="l00294"></a>00294 
<a name="l00307"></a>00307         <span class="keywordtype">void</span> fileDownloadFinished(<span class="keyword">const</span> QString&amp; filename);
<a name="l00308"></a>00308 
<a name="l00324"></a>00324         <span class="keywordtype">void</span> fileDownloadProgress(<span class="keyword">const</span> QString&amp; filename, qint64 done, qint64 total);
<a name="l00325"></a>00325 
<a name="l00334"></a>00334         <span class="keywordtype">void</span> fileDownloadStarted(<span class="keyword">const</span> QString&amp; filename, <span class="keyword">const</span> QUrl&amp; url);
<a name="l00335"></a>00335 
<a name="l00344"></a>00344         <span class="keywordtype">void</span> fileInstalled(<span class="keyword">const</span> QString&amp; filename);
<a name="l00345"></a>00345 
<a name="l00353"></a>00353         <span class="keywordtype">void</span> message(<span class="keyword">const</span> QString&amp; msg, WadseekerLib::MessageType type);
<a name="l00354"></a>00354 
<a name="l00363"></a>00363         <span class="keywordtype">void</span> seekStarted(<span class="keyword">const</span> QStringList&amp; filenames);
<a name="l00364"></a>00364 
<a name="l00368"></a>00368         <span class="keywordtype">void</span> siteFinished(<span class="keyword">const</span> QUrl&amp; site);
<a name="l00369"></a>00369 
<a name="l00373"></a>00373         <span class="keywordtype">void</span> siteProgress(<span class="keyword">const</span> QUrl&amp; site, qint64 bytes, qint64 total);
<a name="l00374"></a>00374 
<a name="l00378"></a>00378         <span class="keywordtype">void</span> siteRedirect(<span class="keyword">const</span> QUrl&amp; oldUrl, <span class="keyword">const</span> QUrl&amp; newUrl);
<a name="l00379"></a>00379 
<a name="l00383"></a>00383         <span class="keywordtype">void</span> siteStarted(<span class="keyword">const</span> QUrl&amp; site);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385     <span class="keyword">private</span>:
<a name="l00386"></a>00386         <span class="keyword">class </span>SeekParameters
<a name="l00387"></a>00387         {
<a name="l00388"></a>00388             <span class="keyword">public</span>:
<a name="l00389"></a>00389                 <span class="keywordtype">bool</span> bIdgamesEnabled;
<a name="l00390"></a>00390                 QUrl customSiteUrl;
<a name="l00391"></a>00391                 QString idgamesUrl;
<a name="l00392"></a>00392                 <span class="keywordtype">unsigned</span> maxConcurrentDownloads;
<a name="l00393"></a>00393                 <span class="keywordtype">unsigned</span> maxConcurrentSeeks;
<a name="l00394"></a>00394                 QString saveDirectoryPath;
<a name="l00395"></a>00395                 QStringList seekedWads;
<a name="l00396"></a>00396                 QStringList sitesUrls;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398                 SeekParameters();
<a name="l00399"></a>00399         };
<a name="l00400"></a>00400 
<a name="l00401"></a>00401         <span class="keyword">class </span>PrivData
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403             <span class="keyword">public</span>:
<a name="l00404"></a>00404                 <span class="keywordtype">bool</span> bIsAborting;
<a name="l00405"></a>00405 
<a name="l00418"></a>00418                 QList&lt;Idgames* &gt; idgamesClients;
<a name="l00419"></a>00419 
<a name="l00420"></a>00420                 SeekParameters seekParameters;
<a name="l00421"></a>00421 
<a name="l00427"></a>00427                 SeekParameters* seekParametersForCurrentSeek;
<a name="l00428"></a>00428 
<a name="l00429"></a>00429                 WadRetriever* wadRetriever;
<a name="l00430"></a>00430                 WWWSeeker* wwwSeeker;
<a name="l00431"></a>00431         };
<a name="l00432"></a>00432 
<a name="l00433"></a>00433         PrivData d;
<a name="l00434"></a>00434 
<a name="l00435"></a>00435         <span class="keywordtype">void</span> cleanUpAfterFinish();
<a name="l00436"></a>00436         <span class="keywordtype">bool</span> isAllFinished() <span class="keyword">const</span>;
<a name="l00437"></a>00437 
<a name="l00441"></a>00441         <span class="keywordtype">void</span> prepareSeekObjects();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443         <span class="keywordtype">void</span> setupIdgamesClients(<span class="keyword">const</span> QList&lt;WadDownloadInfo&gt;&amp; wadDownloadInfoList);
<a name="l00444"></a>00444         <span class="keywordtype">void</span> setupSitesUrls();
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447         <span class="keywordtype">void</span> startNextIdgamesClient();
<a name="l00448"></a>00448 
<a name="l00449"></a>00449     <span class="keyword">private</span> slots:
<a name="l00450"></a>00450         <span class="keywordtype">void</span> fileLinkFound(<span class="keyword">const</span> QString&amp; filename, <span class="keyword">const</span> QUrl&amp; url);
<a name="l00451"></a>00451         <span class="keywordtype">void</span> idgamesClientFinished(Idgames* pEmitter);
<a name="l00452"></a>00452         <span class="keywordtype">void</span> wadRetrieverDownloadFinished(WadDownloadInfo wadDownloadInfo);
<a name="l00453"></a>00453         <span class="keywordtype">void</span> wadRetrieverDownloadProgress(WadDownloadInfo wadDownloadInfo, qint64 current, qint64 total);
<a name="l00454"></a>00454         <span class="keywordtype">void</span> wadRetrieverDownloadStarted(WadDownloadInfo wadDownloadInfo, <span class="keyword">const</span> QUrl&amp; url);
<a name="l00455"></a>00455         <span class="keywordtype">void</span> wadRetrieverFinished();
<a name="l00456"></a>00456         <span class="keywordtype">void</span> wadRetrieverMessage(<span class="keyword">const</span> QString&amp; message, WadseekerLib::MessageType type);
<a name="l00457"></a>00457         <span class="keywordtype">void</span> wadRetrieverWadInstalled(WadDownloadInfo wadDownloadInfo);
<a name="l00458"></a>00458         <span class="keywordtype">void</span> wwwSeekerAttachmentDownloaded(<span class="keyword">const</span> QString&amp; name, <span class="keyword">const</span> QByteArray&amp; data);
<a name="l00459"></a>00459         <span class="keywordtype">void</span> wwwSeekerFinished();
<a name="l00460"></a>00460 };
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="preprocessor">#endif</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>
</pre></div></div>
</div>
<?php
include '../../footer.php';
?>

